#ifdef LOCAL
#include "../testlib.h"
#else
#include "testlib.h"
#endif

#include <functional>

using namespace std;

const int MAX_NUM = 100'000;
const int MAX_VAL = 1'000'000'000 + 7;

int N_BOUND = MAX_NUM, VAL_BOUND = MAX_VAL;

function<bool(char)> check_char = [](char c) {
  return c == '+' or c == '*' or c == '=';
};

void validate_general() {
  int have = 0;
  bool stop = false;
  while (!stop && have < N_BOUND) {
    have++;
    inf.readInt(0, VAL_BOUND - 1, "number");
    inf.readSpace();
    char c = inf.readChar();
    ensuref(check_char(c), "Expected correct char, got %c", c);
    inf.readSpace();
    if (c == '=') {
      stop = true;
    }
  }
  ensuref(stop, "Read %d numbers but didn't meet '='", N_BOUND);
  inf.readInt(0, MAX_VAL - 1, "result");
  inf.readEoln();
  inf.readEof();
}

int main(int argc, char *argv[]) {
  registerValidation(argc, argv);
  auto group = validator.group();
  if (group == "") {
    group = "0";
  }
  int gn = stoi(group);
  if (gn == 1) {
    N_BOUND = 45;
  } else if (gn == 2) {
    N_BOUND = 100;
  } else if (gn == 3) {
    VAL_BOUND = 10;
  } else if (gn == 4) {
    check_char = [](char c) {
      return c == '+' or c == '=';
    };
  } else if (gn == 5) {
    check_char = [](char c) {
      return c == '*' or c == '=';
    };
  } else if (gn == 6) {
    VAL_BOUND = 100'000;
  }
  validate_general();
}