#include "bits/stdc++.h"

using namespace std;
using ll = long long;

const ll MOD = 1'000'000'000 + 7;

// without "= X"
vector<vector<ll>> get_mul_blocks(const vector<string> &expr) {
  vector<vector<ll>> blocks = {{}};
  for (const string &token : expr) {
    if (token == "+") {
      blocks.emplace_back();
    } else if (token == "*") {
      continue;
    } else {
      blocks.back().push_back(stoll(token));
    }
  }
  return blocks;
}

vector<int> changed_block;
vector<ll> block_prod;

ll eval(const vector<vector<ll>> &blocks) {
  ll sum = 0;
  for (int i = 0; i < blocks.size(); i++) {
    ll prod = 1;
    if (changed_block[i] == 0) {
      prod = block_prod[i];
    } else {
      for (ll x : blocks[i]) {
        prod = (prod * x) % MOD;
      }
    }
    sum += prod;
    if (sum >= MOD) sum -= MOD;
  }
  return sum;
}

ll get_number_len(ll x) {
  int len = 1;
  ll bound = 10;
  while (x >= bound) {
    len++;
    bound *= 10;
  }
  return len;
}

ll set_digit(ll x, ll i, ll new_val) {
  if (i == 0) {
    ll old = (x / 1) % 10;
    return x + (new_val - old) * 1;
  } else if (i == 1) {
    ll old = (x / 10) % 10;
    return x + (new_val - old) * 10;
  } else if (i == 2) {
    ll old = (x / 100) % 10;
    return x + (new_val - old) * 100;
  } else if (i == 3) {
    ll old = (x / 1000) % 10;
    return x + (new_val - old) * 1000;
  } else if (i == 4) {
    ll old = (x / 10000) % 10;
    return x + (new_val - old) * 10000;
  } else if (i == 5) {
    ll old = (x / 100000) % 10;
    return x + (new_val - old) * 100000;
  } else if (i == 6) {
    ll old = (x / 1000000) % 10;
    return x + (new_val - old) * 1000000;
  } else if (i == 7) {
    ll old = (x / 10000000) % 10;
    return x + (new_val - old) * 10000000;
  } else if (i == 8) {
    ll old = (x / 100000000) % 10;
    return x + (new_val - old) * 100000000;
  } else { // i = 9
    ll old = (x / 1000000000) % 10;
    return x + (new_val - old) * 1000000000;
  }
}

vector<vector<ll>> num_lengths;

// returns true if found correct modification
// if found, blocks are changed
bool change_rec(vector<vector<ll>> &blocks, ll want, int depth, int bi = 0, int ni = 0) {
  if (eval(blocks) == want) {
    return true;
  }
  if (depth == 0) return false;
  for (int i = bi; i < blocks.size(); i++) {
    vector<ll> &block = blocks[i];
    int sj = ni;
    if (i > bi) sj = 0;
    for (int j = sj; j < block.size(); j++) {
      ll &x = block[j];
      ll old_value = x;

      ll len = num_lengths[i][j];
      for (int d = 0; d < len; d++) {
        int start = 0;
        if (d + 1 == len && len > 1) start = 1;
        for (int new_digit = start; new_digit < 10; new_digit++) {
          x = set_digit(x, d, new_digit);
          changed_block[i]++;
          if (x >= MOD){
            break;
          }
          if (x != old_value && change_rec(blocks, want, depth - 1, i, j)) return true;
          changed_block[i]--;
          x = old_value;
        }
      }
    }
  }
  return false;
}

void solve() {
  vector<string> input;
  string s;
  while (cin >> s) {
    input.push_back(s);
  }
  ll want = stoll(input.back());
  input.pop_back(); // want
  input.pop_back(); // =

  auto parsed = get_mul_blocks(input);
  num_lengths = parsed;
  changed_block.resize(parsed.size(), 0);
  block_prod.resize(parsed.size(), 1);
  for (int i = 0; i < parsed.size(); i++) {
    for (ll x : parsed[i]) {
      block_prod[i] = (block_prod[i] * x) % MOD;
    }
  }
  for (vector<ll> &bl : num_lengths) {
    for (ll &x : bl) {
      x = get_number_len(x);
    }
  }
  auto old = parsed;
  if (!change_rec(parsed, want, 2)) {
    cout << "NO\n";
    return ;
  }
  cout << "YES\n";
  vector<pair<int, ll>> answer;
  int pos = 1;
  for (int i = 0; i < parsed.size(); i++) {
    for (int j = 0; j < parsed[i].size(); j++) {
      if (parsed[i][j] != old[i][j]) {
        answer.emplace_back(pos, parsed[i][j]);
      }
      pos++;
    }
  }
  cout << answer.size() << "\n";
  for (auto p : answer) {
    cout << p.first << " " << p.second << "\n";
  }
  assert(eval(parsed) == want);
}

int main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);

  solve();
}
