#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <utility>
#include <sstream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <string>
 
 
using namespace std;
#define len(v) (int)(v).size()
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int long long
 
struct segtree {
    vector<int> tree;
    int len1;
 
    void init(int n) {
        len1 = n;
        tree.assign(4 * n, -1e18);
    }
 
    void build(vector<int> &a, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = a[lx];
            return;
        } else {
            int m = (lx + rx) / 2;
            build(a, 2 * x + 1, lx, m);
            build(a, 2 * x + 2, m, rx);
            tree[x] = max(tree[2 * x + 1], tree[2 * x + 2]);
        }
    }
 
    void build(vector<int> &a) {
        init(len(a));
        build(a, 0, 0, len1);
    }
 
    int maximum(int l, int r, int x, int lx, int rx) {
        if (l >= rx || r <= lx) {
            return -1e18;
        }
        if (lx >= l && rx <= r) {
            return tree[x];
        }
        int m = (lx + rx) / 2;
        int num1 = maximum(l, r, 2 * x + 1, lx, m);
        int num2 = maximum(l, r, 2 * x + 2, m, rx);
        return max(num1, num2);
    }
 
    int get_max(int l, int r) {
        return maximum(l, r, 0, 0, len1);
    }
};
 
void solve() {
    int n, H;
    cin >> n >> H;
    vector<pair<int, int>> a(n);
    bool k1 = true;
    for (int i = 0; i < n; ++i) { cin >> a[i].first; }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].second;
        if (a[i].second != 1) k1 = false;
    }
    sort(all(a));
    int ans = 1e18;
    vector<int> pref(n + 1);
    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + a[i].second;
        if (a[i].second >= H) {
            cout << 0;
            return;
        }
    }
 
    vector<int> raz(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        raz[i] = a[i + 1].first - a[i].first;
    }
    segtree st;
    st.build(raz);
    for (int i = 0; i < n - 1; ++i) {
        int l = i, r = n;
        bool have = 0;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            int mx = st.get_max(i, mid);
            int sm = pref[mid + 1] - pref[i];
            if (sm >= H) {
                have = 1;
                r = mid;
                ans = min(ans, mx);
            } else {
                l = mid;
            }
        }
        if (!have) continue;
        int mx = st.get_max(i, r);
        ans = min(ans, mx);
    }
    cout << ans;
 
}
 
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
