#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), m = opt<int>("m");
    n = n - n % (3 * m) + 1;
    int p = opt<int>("p"), max_bit = has_opt("bits") ? opt<int>("bits") : 28;
    auto op_pool = split(opt<string>("ops"), ",");

    int d = rnd.next(n);
    println(n, m, d, p);

    auto block = [&]() {
        return rnd.next(max(1, static_cast<int>(p / 1.2)), static_cast<int>(1.2 * p));
    };

    vector<int> a(n);
    for (int bit = 0; bit < max_bit; bit++) {
        int start = rnd.next(n);
        int end = block();
        unsigned int value = rnd.next(0u, 1u);
        for (int i = 0; i < n; i++) {
            int j = (start + i * 3 * m) % n;
            if (i == end) {
                end += block();
                value ^= 1;
            }
            a[j] |= value << bit;
        }
    }
    println(a.begin(), a.end());

    vector<string> ops(m);
    for (string &op : ops) op = rnd.any(op_pool);
    println(ops.begin(), ops.end());

}