#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);
    int group = validator.group().size() ? atoi(validator.group().c_str()) : 0;

    int const N = 200'000, M = 10, P = 1000'000'000;
    int const A = 1000'000'000;

    int n = inf.readInt(1, N, "n");
    inf.readSpace();
    int m = inf.readInt(1, M, "m");
    inf.readSpace();
    inf.readInt(0, n - 1, "d");
    inf.readSpace();
    int p = inf.readInt(1, P, "p");
    inf.readEoln();

    if (group == 1) {
        ensuref(n <= 1000, "group 1: n = %d > 1000", n);
        ensuref(p <= 100, "group 1: p = %d > 100", p);
    } else if (group == 2) {
        ensuref(m == 1, "group 2: m = %d != 1", m);
    }

    auto a = inf.readInts(n, 0, A, "a");
    inf.readEoln();

    if (group == 5) {
        ensuref(*max_element(a.begin(), a.end()) <= 1, "group 5: max element of a exceeds 1");
    }

    auto op = inf.readTokens(m, "xor|and|or", "op");
    inf.readEoln();

    if (group == 3) {
        ensuref(set<string>(op.begin(), op.end()).size() == 1, "group 3: elements of ops differ");
    } else if (group == 4) {
        ensuref(count(op.begin(), op.end(), "xor") == 0, "group 4: xor is present in ops");
    }

    inf.readEof();

}