/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef unsigned int uint;
typedef long long ll;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    in(int, n, m, d, p)
    vector<uint> a(n);
    vector<string> op(m);
    cin >> a;

    vector<int> idx_xor, idx_and, idx_or;
    for (int i = 0; i < m; i++) {
        cin >> op[i];
        if (op[i] == "xor") idx_xor.push_back(i);
        else if (op[i] == "and") idx_and.push_back(i);
        else if (op[i] == "or") idx_or.push_back(i);
    }

    vector<vector<int>> cycles;
    vector<vector<int>> cycles_xor;
    vector<pii> pos(n, {-1, -1});
    for (int i = 0; i < n; i++) {
        if (pos[i].first != -1) continue;

        int c = cycles.size();
        cycles.emplace_back();
        cycles_xor.push_back({0});
        auto &cycle = cycles.back();
        auto &cycle_xor = cycles_xor.back();

        int cur = i;
        while (pos[cur].first == -1) {
            pos[cur] = {c, cycle.size()};
            cycle.push_back(cur);
            cycle_xor.push_back(cycle_xor.back() ^ a[cur]);
            cur += m * d;
            if (cur >= n) cur %= n;
        }
    }

    auto seg_xor = [&](int start, int length) {
        auto [c, idx] = pos[start];
        auto &cycle = cycles[c];
        uint value = (length / cycle.size()) % 2 == 0 ? 0 : cycles_xor[c].back();
        length %= cycle.size();
        if (idx + length <= cycle.size()) {
            value ^= cycles_xor[c][idx + length] ^ cycles_xor[c][idx];
        } else {
            value ^= cycles_xor[c].back() ^ cycles_xor[c][idx + length - cycle.size()] ^ cycles_xor[c][idx];
        }
        return value;
    };

    vector<uint> b(n);
    vector<int> dist_0, dist_1;
    int const inf = max(n, p) + 1;
    for (int bit = 0; bit < 30; bit++) {
        dist_0.assign(n, inf), dist_1.assign(n, inf);
        for (auto &cycle : cycles) {
            int sz = cycle.size();
            for (int j = 0; j < 2 * sz; j++) {
                int k = j < sz ? j : j - sz;
                int prev = k > 0 ? k - 1 : sz - 1;
                dist_0[cycle[k]] = (a[cycle[k]] >> bit & 1) == 0 ? 0 : dist_0[cycle[prev]] + 1;
                dist_1[cycle[k]] = (a[cycle[k]] >> bit & 1) == 1 ? 0 : dist_1[cycle[prev]] + 1;
            }
        }

        for (int i = 0; i < n; i++) {
            int root = (i + d + static_cast<ll>(p - 1) * m * d) % n;
            int rem_it = p - 1, last_idx = -1;
            uint value = a[i] >> bit & 1;
            for (int idx : idx_and) {
                int item = (root + idx * d) % n, zero_it = dist_0[item];
                if (zero_it <= rem_it) {
                    rem_it = zero_it, last_idx = idx;
                    value = 0;
                }
            }
            for (int idx : idx_or) {
                int item = (root + idx * d) % n, one_it = dist_1[item];
                if (one_it < rem_it || one_it == rem_it && idx > last_idx) {
                    rem_it = one_it, last_idx = idx;
                    value = 1;
                }
            }

            int tail = (i + d + static_cast<ll>(p - rem_it) * m * d) % n;
            for (int idx : idx_xor) {
                int length = rem_it, start = (tail + idx * d) % n;
                if (idx > last_idx) {
                    length++;
                    start = (start - m * d) % n;
                    if (start < 0) start += n;
                }
                value ^= (seg_xor(start, length) >> bit & 1);
            }

            b[i] |= value << bit;
        }
    }

    for (int i = 0; i < n; i++) cout << b[i] << ' ';
    cout << '\n';

}